import QtQuick 2.12
import QtQuick.Controls 2.12

ApplicationWindow {
    id: win
    width: 800
    height: 500
    visible: true

    Page {
        anchors.fill: parent

        MouseArea {
            anchors.fill: parent
            onClicked: {
                //New item data initialization
                var newItem = {};
                //Click point position
                newItem.xpos = mouseX;
                newItem.ypos = mouseY;
                //Random color
                newItem.col = Qt.rgba(Math.random(), Math.random(), Math.random()).toString();
                //Appends new item
                listModel.append(newItem);
            }
        }

        //Repeater - item view without positioning
        //Manages dynamic delegate items using provided model
        Repeater {
            model: listModel
            Rectangle {
                width: 50
                height: width
                radius: width/2
                color: col
                x: xpos - radius
                y: ypos - radius
                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        //Item self-destruction by click/tap through model
                        listModel.remove(index);
                    }
                }
                //Makes item draggable
                DragHandler {}
            }
        }
        Button {
            text: "Clear"
            onClicked: {
                //Clear all model items by click/tap
                listModel.clear();
            }
        }
    }

    //Model stores and manages items data
    ListModel {
        id: listModel
    }
}
